#include "UserDb.h"

using namespace userdb;

UserDb::UserDb()
{
}

User UserDb::user_by_pin(String cmp)
{
    Serial.println("Searching for user with pin number " + cmp);
    Iterator it = begin_with_filter(&cmp,USERATTRIBUTES::USER_PIN);
    do
    {
        User temp = *it;
        if (temp.enabled)
            return temp;
        ++it;
    } while (it.has_next());
    return User{.enabled = false};
}
User UserDb::user_by_rfid(String cmp)
{
    Serial.println("Searching for user with rfid " + cmp);
    Iterator it = begin_with_filter(&cmp,USERATTRIBUTES::RFID_UID);
    do
    {
        User temp = *it;
        if (temp.enabled)
            return temp;
        ++it;
    } while (it.has_next());
    return User{.enabled = false};
}

User UserDb::user_by_uid(unsigned long cmp){
    Serial.println("Searching for user with user id " + String(cmp));
    Iterator it = begin();
    do
    {
        User temp = *it;
        if (temp.uid == cmp)
            return temp;
        ++it;
    } while (it.has_next());
    return User{.enabled = false};
}
void UserDb::print_to_serial()
{
    Serial.println("Starting UserDB Test Read");
    for(Iterator it = begin(); it.has_next(); ++it){
        User temp = *it;
        Serial.println(temp.toString());
    }
}
