#pragma once
#include <Arduino.h>
#include <set>
#include <vector>
#include "Persistence.h"
class Users
{
public:
    enum ATTRIBUTES{
        FIRST_NAME,
        LAST_NAME,
        RFID_UID,
        USER_PIN
    };
    typedef struct User
    {
        //User(unsigned long new_uid): uid(new_uid){}
        unsigned long uid;
        mutable String first_name;
        mutable String last_name;
        mutable String rfid_uid;
        mutable String user_pin;
        mutable bool enabled = true;
        bool operator < (const User &o) const { return uid <o.uid; }
        bool operator == (const User &o) const { return uid ==o.uid; }
        
    } user_account;

private:
    std::set<User> _userdb;
    Persistence &persistence;
    /* data */
public:
    Users(Persistence &persistence);
    ~Users();
    bool checkRfid(String rfid_code, std::vector<Users::User> *logon_users);
    bool checkPin(String pin_code, std::vector<Users::User> *logon_users);
    unsigned long addUser(String first_name, String last_name, String rifd_uid, String user_pin);
    bool delUser(unsigned long id);
    bool updateUser(unsigned long id, ATTRIBUTES attr, String value);
    String toString(User *user);
    bool ImportFromPersistence();
    bool ExportToPersistence();
    void PrintAllToSerial();
    size_t countUsers();
};